#!/bin/sh

set -euo pipefail

# Create roles needed for patroni
{{ with secret "[[ .vault.root ]]kv/service/[[ .instance ]]" }}
psql <<'_EOSQL'
  ALTER ROLE postgres WITH SUPERUSER LOGIN PASSWORD '{{ .Data.data.pg_pwd }}';
  CREATE ROLE replicator WITH LOGIN REPLICATION PASSWORD '{{ .Data.data.replicator_pwd }}';
  CREATE ROLE rewind WITH LOGIN PASSWORD '{{ .Data.data.rewind_pwd }}';
  CREATE ROLE vault WITH LOGIN SUPERUSER PASSWORD '{{ .Data.data.vault_initial_pwd }}';
  CREATE ROLE monitor WITH LOGIN PASSWORD '{{ .Data.data.monitor_pwd }}';
  GRANT "pg_monitor" TO "monitor";
_EOSQL
{{ end }}
